#!/usr/bin/perl -w
#
# Acrotsr - an acrobot whoo
# Copyright (C) 2000 Zachary P. Landau <kapheine@hypa.net>
#
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#

#use strict;
use Net::IRC;

my $debug = 1;
my $irc = new Net::IRC;

my $version = "0.8.0";

my @servers = qw(irc.concentric.net irc1.phoenix.net irc.mcs.net irc.ais.net irc.idle.net);
my $server;
my $port = 6667;
my $nick = "changeme";
my $trynick = $nick;
my $ircname = "I'm to lame for grammar.";
my $username = "changeme";
my $versionreply = "ircII EPIC4-2000 Linux 2.2.14";

my $quit = 0;

my %game;
$game{'active'} = 0;
$game{'defrounds'} = 10;
$game{'totalrounds'} = $game{'defrounds'};
$game{'round'} = 1;
$game{'channel'} = "#changeme";
$game{'guessdelay'} = 45; 
$game{'warning'} = 10;    
$game{'votedelay'} = 25;  
$game{'rounddelay'} = 15; 
$game{'maxacro'} = 6;
$game{'minacro'} = 3;
$game{'acronym'} = "BLEH";
$game{'stage'} = "BLEH";
$game{'minentries'} = 3;
$game{'scorefile'} = "scores.data";
$game{'scoreoutput'} = 1;

my %totalscore;
my %currentscore;
my %entries;
my %voted;
undef %voted;
my %choice;
my %hostnames;

my @authhosts;
my @names;
my $password = "AThOPBVbNY1Ro";
my $time;
my $nicktime;
my $length;
my $record;

my @chars = (qw(A A A A A B C D E E E E E F G H H H H H I I I I I J K L M N N N N N O O O O O P Q R R R R R S S S S S T T T T T U U U V W X Y Y Y Z));

my $count;
my $curnick;
my $output;
my $done=0;
my $connected;
my $connection;
my $noinput = 0;

sub rotate ( \@ ) {       # taken from the perl cookbook, p120
  my $listref = shift;
  my $element = $listref->[0];
  push(@$listref, shift @$listref);
  return $element;
}

sub do_connect {
  $connected = 1;
  $server = rotate(@servers);
  print "Trying to connect to $server\n" if $debug;
  $connection = $irc->newconn(Server   => $server,
                              Port     => $port,
                              Nick     => $nick,
                              Ircname  => $ircname,
                              Username => $username)
      or $connected = 0;
}

sub on_connect {
  my $self = shift;

  print "Joining $game{'channel'}.\n" if $debug;
  $self->join($game{'channel'});
}

sub on_init {
  my ($self, $event) = @_;
  my (@args) = ($event->args);
  shift (@args);
 
  print "*** @args\n" if $debug;
}

sub on_nick_taken {
  my ($self) = shift;

  do {
    $trynick = $trynick . "_";
    $connection->nick($trynick);
  } while ($connection->nick ne $trynick);
 
}

sub on_msg {
  my ($self, $event) = @_;
  my ($nick) = $event->nick;
  my ($arg) = ($event->args);
  my ($hostname) = ($event->userhost);
  my $check;
  my $entry;
  my $access;
  my (@params);

  $hostnames{"$hostname"} = $nick;

  print "*$nick* ", ($event->args), "\n" if $debug;
  if ($arg =~ /^\.access ([A-Za-z0-9]+)/i) {
    if (crypt($1, $password) eq $password) {
       print "Access granted to $nick($hostname)\n" if $debug;
       $self->privmsg($nick, "Access granted to $nick($hostname)");
       push(@authhosts, $hostname);
    } else {
       print "Access denied to $nick($hostname)\n" if $debug;
       $self->privmsg($nick, "Access denied to $nick($hostname)");
    }
  }

  foreach $check (@authhosts) {
    if ($check eq $hostname) {
      $access = 1;
    }
  }

  if ($arg =~ /^\.guessdelay /i && $access == 1) {
    @params = split(/ /, $arg);
    $game{'guessdelay'} = $params[1];
    $connection->privmsg($nick, "Guessdelay changed to $params[1]");
  }

  if ($arg =~ /^\.warning /i && $access == 1) {
    @params = split(/ /, $arg);
    $game{'warning'} = $params[1];
    $connection->privmsg($nick, "Warning changed to $params[1]");
  }

  if ($arg =~ /^\.votedelay /i && $access == 1) {
    @params = split(/ /, $arg);
    $game{'votedelay'} = $params[1];
    $connection->privmsg($nick, "Votedelay changed to $params[1]");
  }

  if ($arg =~ /^\.rounddelay /i && $access == 1) {
    @params = split(/ /, $arg);
    $game{'rounddelay'} = $params[1];
    $connection->privmsg($nick, "Rounddelay changed to $params[1]");
  }

  if ($arg =~ /^\.defrounds /i && $access == 1) {
    @params = split(/ /, $arg);
    $game{'defrounds'} = $params[1];
    $connection->privmsg($nick, "Defrounds changed to $params[1]");
  }

  if ($arg =~ /^\.minentries /i && $access == 1) {
    @params = split(/ /, $arg);
    $game{'minentries'} = $params[1];
    $connection->privmsg($nick, "Minentries changed to $params[1]");
  }

  if ($arg =~ /^\.help/i && $access == 1) {
    $connection->privmsg($nick, "defrounds \# / guessdelay \# : warning \# : votedelay \# : rounddelay \# : minentries \# : reconnect : op : join : leave/part : quit");
  }

  if ($arg =~ /^\.quit/i && $access == 1) {
    $quit = 1;
    $connection->quit("Requested to leave.");
  }

  if ($arg =~ /^\.reconnect/i && $access == 1) {
    $connection->quit("Changing servers.");
  }

  if ($arg =~ /^\.op/i && $access == 1) {
    $self->mode($game{'channel'}, "+o", $event->nick);
  }

  if ($arg =~ /^\.join/i && $access == 1) {
    $self->join($game{'channel'});
  }

  if (($arg =~ /^\.leave/ || $arg =~ /^\.part/) && $access == 1) {
    $self->part($game{'channel'});
  }

  if ($arg =~ /^acro /i && $game{'active'} == 1) {
    $entry = substr($arg, 5, length($arg));
    if ($game{'stage'} eq "submit") {
      if (&parse_entry($entry) == 0) {
        $self->privmsg($nick, "Entry \"$entry\" has been accepted.");
        $entries{"$hostname"} = $entry;
        $totalscore{"$hostname"} = 0 unless defined($totalscore{"$hostname"});
        $currentscore{"$hostname"} = 0 unless defined($currentscore{"$hostname"});
      } else {
        $self->privmsg($nick, "Entry \"$entry\" has been rejected.");
      } 
    }
    if ($game{'stage'} eq "vote") {
      &parse_vote($nick, $hostname, $entry);
    }
  }

  undef $access;
}

sub parse_entry {
  my ($entry) = @_;
  my @words;
  my @letters;
  my $failed = 0;

  if ($entry =~ /[@\-_$%^&*()|~\\\/]/) {
    $failed = 1;
  }

  @words = split(/ /, $entry);
  @letters = split(//, $game{'acronym'});


  $count = 0;

  foreach $record (@letters) {
    if ($record ne uc(substr($words[$count], 0, 1))) {
      $failed = 1;
    }
    $count++;
  }

  return($failed);
}

sub parse_vote {
  my ($nick, $hostname, $entry) = @_;
  my ($inchan);
#  my $length = length(%entries);
  my (%count);

  if ($voted{"$hostname"} == 1) {
    $connection->privmsg($nick, "Already voted.");
    return 1;
  }

  $length = length(%entries);

  if ((!$choice{$entry}) || ($entries{$count{$entry}})) {
    $connection->privmsg($nick, "Invalid entry number. ($entries{$count{$entry}})");
    return 2;
  }

  if ($hostname eq $choice{$entry}) {
    $connection->privmsg($nick, "Cannot vote for yourself.");
    return 3;
  }

  $inchan = 0;

  foreach $record (@names) {
    if ($nick eq $record) {
      $inchan = 1;
    }
  }
  if ($inchan == 0) {
    $connection->privmsg($nick, "Cannot vote outside of channel.");
    return 4;
  }

  $count = 1;
  $voted{"$hostname"} = 1;
  $connection->privmsg($nick, "Vote for $entry accepted.");

  $currentscore{"$choice{$entry}"}++;
  $totalscore{"$choice{$entry}"}++;
}

sub display_choices {

  $curnick = $connection->nick;

  $count=1;
  $connection->privmsg($game{'channel'}, "Number Entry");
  foreach $record (keys(%entries)) {
    $choice{$count} = $record;
    $output = sprintf("%4.4s   %.50s", $count, $entries{"$record"});
    $connection->privmsg($game{'channel'}, $output);
    $count++;
  }
}

sub display_results {
  my ($nick, $entry, $score, $total);

  $connection->privmsg($game{'channel'}, "Nick       Entry Number  Score  Total Score");
  $entry = 0;
  foreach $record (keys(%entries)) {
    $nick = $hostnames{"$record"};
    $entry++;
    $score = $currentscore{"$record"};
    $total = $totalscore{"$record"};
    $output = sprintf("%-10s %6s      %5s     %6s", $nick, $entry, $score, $total);
    $connection->privmsg($game{'channel'}, $output);
  }
}

sub on_public {
  my ($self, $event) = @_;
  my @to = $event->to;
  my ($nick) = ($event->nick);
  my ($arg) = ($event->args);
  my ($hostname) = ($event->userhost);
  my (@params);

  if ($arg =~ /^\!start/ && $game{'active'} == 0) {
    @params = split(/ /, $arg);
    if ($params[1]) {
      $game{'totalrounds'} = $params[1];
      $connection->privmsg($game{'channel'}, "Starting new game with $game{'totalrounds'} rounds.");
    } else {
      $game{'totalrounds'} = $game{'defrounds'};
      $connection->privmsg($game{'channel'}, "Starting new game.");
    }
    print "Starting a new game (requested by $nick)\n" if $debug;
    &clear_game_stats();
    $game{'active'} = 1;
  }

  if ($arg =~ /^\!stop/ && $game{'active'} == 1) {
    print "Stopping a new game (requested by $nick)\n" if $debug;
    $game{'active'} = 0;
    $connection->privmsg($game{'channel'}, "Game has been stopped.");
  }

}
 
sub clear_game_stats {
  undef @names;
  undef %totalscore;
  undef %currentscore;
  undef %entries;
  undef %voted;
  undef %choice;
  undef %hostnames;
  $game{'round'} = 1;
  $noinput=0;
}
  
sub clear_round_stats {
  undef @names;
  undef %currentscore;
  undef %entries;
  undef %voted;
  foreach $record (keys(%choice)) { $choice{"$record"} = 0; }
}

sub generate_acronym {
  my ($acrolength);

  $acrolength = int(rand 3)+3;
  $game{'acronym'} = join("", @chars [ map { rand @chars } (1..$acrolength) ]);
}

sub game_over {
  my ($nick, $total);

  (open (SCOREFILE, ">>$game{'scorefile'}") or (print "WARNING: Cannot open $game{'scorefile'}\n")) if $game{'scoreoutput'};

  $game{'active'} = 0;
  $connection->privmsg($game{'channel'}, "Game has ended.");
  $connection->privmsg($game{'channel'}, "Nick       Total Score");
  foreach $record (keys(%totalscore)) {
    $nick = $hostnames{"$record"};
    $total = $totalscore{"$record"};
    $output = sprintf("%-10s  %6s", $nick, $total);
    $connection->privmsg($game{'channel'}, $output);
    print SCOREFILE "$nick:$total\n" if $game{'scoreoutput'};
  }

  close(SCOREFILE) if $game{'scoreoutput'};
}

sub on_names {
  my ($self, $event) = @_;
  my (@users, $channel) = ($event->args);
  my (@tmpnames, @name);

  ($channel, @name) = splice @users, 2;

  $name[0] =~ s/[@\+]//g;
  @names = split(/ /, $name[0]);
}

sub remove_host {
  my ($self, $event) = @_;
  my ($hostname) = ($event->userhost);
  my @tmphosts;

  foreach $record (@authhosts) {
    if ($hostname ne $record) {
      push(@tmphosts, $record)
    }
  }

  @authhosts = @tmphosts;
}

sub on_ping {
  my ($self, $event) = @_;
  my $nick = $event->nick;

  $self->ctcp_reply($nick, join (' ', ($event->args)));
}

sub on_version {
  my ($self, $event) = @_;
  my $nick = $event->nick;

  $self->ctcp_reply($nick, "VERSION $versionreply");
}

sub on_disconnect {
  my ($self, $event) = @_;

  die("Program completed.\n") if $quit;

#  print "Disconnected from ", $connection->from(), " (", ($connection->args())[0], ")." if $debug;
  print "Attempting to reconnect.\n" if $debug;
#  $connection->connect();
   &do_connect;
}

print "Installing Handlers.\n" if $debug;

while (!$connected) {
  &do_connect;
}

$connection->add_handler('msg', \&on_msg);
$connection->add_handler('public', \&on_public);
$connection->add_handler('part', \&remove_host);
$connection->add_handler('quit', \&remove_host);
$connection->add_handler('cping', \&on_ping);
$connection->add_handler('cversion', \&on_version);

$connection->add_global_handler([ 251,252,253,254,302,255 ], \&on_init);
$connection->add_global_handler('disconnect', \&on_disconnect);
$connection->add_global_handler(376, \&on_connect);
$connection->add_global_handler(433, \&on_nick_taken);
$connection->add_global_handler(353, \&on_names);

$nicktime = time();
while (1) {
  $irc->do_one_loop;
  $curnick = $connection->nick;
  if ((time()-$nicktime > 30) && ($curnick ne $nick)) {
#    &return_nick;
    $connection->nick($nick);
    $nicktime = time();
  }
  while ($game{'active'} == 1) {
    &generate_acronym;     
    $game{'stage'} = "submit";
    $connection->privmsg($game{'channel'}, "Round $game{'round'}: Acronym is $game{'acronym'}");
    $connection->privmsg($game{'channel'}, "/msg $curnick acro entry");
    $connection->privmsg($game{'channel'}, "You have $game{'guessdelay'} seconds");
    $time = time();
    while (time()-$time < $game{'guessdelay'}-$game{'warning'} && $game{'active'} == 1) {
      sleep(1);
      $irc->do_one_loop;
    }
    if ($game{'active'} == 0) { next; }
    $connection->privmsg($game{'channel'}, "$game{'warning'} seconds left");
    $time = time();
    while (time()-$time < $game{'warning'} && $game{'active'} == 1) {
      sleep(1);
      $irc->do_one_loop;
    }
    $length = keys(%entries);
    if ($length < $game{'minentries'}) {
      $connection->privmsg($game{'channel'}, "Not enough entries. Time extended " . ($game{'guessdelay'}/2) . " seconds.");
      $time = time();
      while (time()-$time < ($game{'guessdelay'}/2) && $game{'active'} == 1) {
        sleep(1);
        $irc->do_one_loop;
      }
      $length = keys(%entries);
      if ($length < $game{'minentries'}) {
        $game{'round'}++;
        $noinput++;
        $connection->privmsg($game{'channel'}, "Still not enough entries. Skipping round.");
        if ($noinput == 2) {
          $connection->privmsg($game{'channel'}, "No entries for 2 rounds. Ending game. So there. Hmmph.");
          if (length(%totalscore) > 1) { 
            &game_over;  
          } else { 
            $game{'active'} = 0; 
          }
          last;
        }
        last;
      } else { $noinput = 1; }
    }
    if ($game{'active'} == 0) { next; }
    $game{'stage'} = "vote";
    $connection->privmsg($game{'channel'}, "Time to vote.");
    $connection->names($game{'channel'});
    &display_choices;
    $connection->privmsg($game{'channel'}, "/msg $curnick acro \#. You have $game{'votedelay'} seconds.");
    $time = time();
    while (time()-$time < $game{'votedelay'} && $game{'active'} == 1) {
      sleep(1);
      $irc->do_one_loop;
    }
    if ($game{'active'} == 0) { next; }
    &display_results;
    &clear_round_stats;
    if ($game{'active'} == 0) { 
      $connection->privmsg($game{'channel'}, "Game has ended.");
    }
    $game{'round'}++;
    if ($game{'round'} == $game{'totalrounds'}+1) {
      &game_over;
      next;
    }
    $time = time();
    while (time()-$time < $game{'rounddelay'} && $game{'active'} == 1) {
      sleep(1);
      $irc->do_one_loop;
    }
  }
}
